using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;

namespace Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

public class ChannelProfileSTC : STC
{
    [JsonInclude]
    [JsonPropertyName("id")]
    public long ID { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("displayname")]
    public string DisplayName { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("picture_type")]
    public PictureType PictureType { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("controllers")]
    public long[] Controllers { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("color")]
    public string Color { get; set; } = string.Empty;
}

[JsonSerializable(typeof(ChannelProfileSTC))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
public partial class ChannelProfileSTCContext : JsonSerializerContext;