using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;
using Luski.Shared.PublicServers.V1.Shared;

namespace Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

public class UserRoleOverrideSTC : STC
{
    [JsonInclude]
    [JsonPropertyName("id")]
    public long Id { get; set; }
    [JsonInclude]
    [JsonPropertyName("role_id")]
    public long RoleID { get; set; }
    [JsonInclude]
    [JsonPropertyName("good_permissions")]
    public ServerPermission GoodPermissions { get; set; }
    [JsonInclude]
    [JsonPropertyName("bad_permissions")]
    public ServerPermission BadPermissions { get; set; }
}

[JsonSerializable(typeof(UserRoleOverrideSTC))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
public partial class UserRoleOverrideSTCContext : JsonSerializerContext;